#!/usr/bin/env python

num_isr = 256
pushes_error = [8, 10, 11, 12, 13, 14, 17]

print("""
.intel_syntax noprefix
.extern isr_common
""")

print("// Interrupt Service Routines")
for i in range(num_isr):
    print(f"""isr{i}:
    cli
    {"push 0" if i in pushes_error else "nop"}
    push {i}
    jmp isr_common""")

print("")
print("// Vector table")

print("""
.section .data
.global isr_table
isr_table:""")
for i in range(num_isr):
    print(f""".quad isr{i}""")